require "savan_easy_dates/version"
# require "simple_date_format"
require "date"

module SavanEasyDates
  def day_in_name_month_abbr_year_in_two_digit(date, exp)
		# Friday, Jan 02
		check_if_date(date)
		date.strftime('%A '+ exp +' %b ' + exp + ' %d')
  end

  def date_in_digit(date, exp)
  	# 01/02/2015
		date = check_if_date(date)
  	if exp
  		date.strftime("%m"+exp+"%d"+exp+"%Y")
  	else
  		date.strftime("%m/%d/%Y")
  	end
  end

  def month_full_year(date)
  	# January 2015
  	date = check_if_date(date)
  	date.strftime("%B %Y")
  end
  
  def month_abbr_date_full_year(date)
  	# Jan 03, 2015
  	date = check_if_date(date)
  	date.strftime("%b %d, %Y")
  end

  def day_abbr_date_month_abbr_full_year(date)
  	# Sat, 3 Jan 2015
  	date = check_if_date(date)
  	date.strftime("%a, %e %b %Y")
  end

  def day_name_date_month_abbr_full_year(date)
  	# Saturday, 03 Jan 2015 5:19 PM
		date = check_if_date(date)
  	date.strftime("%A, %d %b %Y %l:%M %p")
  end

  def find_days_between_two_dates(start_date, end_date, displayDay)
    startDate = start_date.to_date
    getEndDateMonth = end_date.to_date.strftime("%m").to_i
    getEndDateYear = end_date.to_date.strftime("%Y").to_i
    endDate = Date.parse "#{end_date}"
    days = []
    days << 0 if displayDay.include?("sunday")
    days << 1 if displayDay.include?("monday")
    days << 2 if displayDay.include?("tuesday")
    days << 3 if displayDay.include?("wednesday")
    days << 4 if displayDay.include?("thursday")
    days << 5 if displayDay.include?("friday")
    days << 6 if displayDay.include?("saturday")
    puts days
    @result = (startDate..endDate).to_a.select {|k| days.include?(k.wday)}
    puts @result
  end

  def default_date(dateToFormat, *args)
    dateToFormat = dateToFormat.to_date.strftime("%Y-%b-%d")
    
    # if args.include?("full_month_name")
    #   formatedDate = dateToFormat.strftime("%Y-%B-%d")
    # end
    # if args.include?("full_year")
    #   formatedDate = formatedDate.to_date.strftime("%Y-%B-%d")
    # end

    return dateToFormat
  end


  private
	  def check_if_date(date)
  		@date = date.to_date
  	end
end

class SexyDates
  include SavanEasyDates
end


# require 'simple_date_format'
# startdate = "2015-2-2"
# enddate = "2015-2-28"
# arr = ["sunday", "monday"]
# a = SimpleDate.new
# a.default_date(startdate, "full_month_name")

# a.find_days_between_two_dates(startdate, enddate, arr)
# a.default_date(startdate)


# jasdeep = ["rails", "savan"]

# case
#   when jasdeep.include?("savan")
#     puts "Hello"
# end